/* **********************************************************
 * Copyright 1998 VMware, Inc.  All rights reserved. -- VMware Confidential
 * **********************************************************/



#ifndef _INITBLOCK_H
#define _INITBLOCK_H

#define INCLUDE_ALLOW_USERLEVEL
#define INCLUDE_ALLOW_MONITOR
#define INCLUDE_ALLOW_MODULE
#include "includeCheck.h"


#include "vm_types.h"


#define MAX_LOGFILE_NAME_LENGTH 256
#define MAX_MONITOR_REGIONS     8
#define MAX_INITBLOCK_CPUS      32
#define INIT_BLOCK_MAGIC     (0x1789+11)
#define INIT_BLOCK_MAGIC_V3  (0x1789+1)

#ifdef _WIN32
#define __attribute__(_x)     // NOP
#include <PSHPACK1.H> // 1-byte packing alignment
#endif


typedef struct InitBlock {
   uint32 magicNumber;     /* Magic number (INIT_BLOCK_MAGIC) */
   int logFD;
#ifdef _WIN32
   int usercallHandle;
#endif
   Vcpuid numVCPUs;
   void *crosspage[MAX_INITBLOCK_CPUS];
} __attribute__ ((packed)) InitBlock;

#ifdef WIN32
#include <POPPACK.H>
#endif

typedef struct InitBlockG25 {
   uint32 magicNumber;     /* Magic number (INIT_BLOCK_MAGIC_V3) */
   uint32 flags;           /* option flags  (see below) */
   int logFD;
#ifdef _WIN32
   char logFileName[MAX_LOGFILE_NAME_LENGTH];
#endif
   void *sharedArea;
   Vcpuid numVCPUs;
   void *crosspage[MAX_INITBLOCK_CPUS];

   /*
    * output 
    */
   VmTimeStart st;

} InitBlockG25;

typedef struct InitBlock30 {
   uint32 magicNumber;     /* Magic number (INIT_BLOCK_MAGIC_V3) */
   uint32 flags;           /* option flags  (see below) */
   int logFD;
#ifdef _WIN32
   char logFileName[MAX_LOGFILE_NAME_LENGTH];
#endif
   void *sharedArea;
   void *crosspage;

   /*
    * output 
    */
   VmTimeStart st;

} InitBlock30;

typedef struct InitBlock20 {
   uint32 magicNumber;     /* Magic number (INIT_BLOCK_MAGIC_V3) */
   uint32 flags;           /* option flags  (see below) */
   int logFD;
#ifdef _WIN32
   char logFileName[MAX_LOGFILE_NAME_LENGTH];
#endif
   void *sharedArea;
   void *crosspage;

   /*
    * output 
    */
   VmTimeStart20 st;
   Bool        smpMachine;

} InitBlock20;

/*
 * Option flags 
 */
/* None yet */

#endif
